# struct SemanticVersion::Prerelease

- SemanticVersion::Prerelease
- Struct
- Value
- Object

##
Overview

Contains the pre-release version related to this semantic version

##
Defined in:

##
Constructors

- .new(identifiers : Array(String | Int32) = [] of String | Int32)

  Creates a new `Prerelease` instance with supplied array of identifiers

- .parse(str : String) : self

  Parses a `Prerelease` from the given pre-release version string

##
Instance Method Summary

- #<=>(other : self) : Int32

  The comparison operator.

- #identifiers : Array(String | Int32)

  Array of identifiers that make up the pre-release metadata

- #to_s(io : IO) : Nil

  Returns the string representation of this semantic version's pre-release metadata

### Instance methods inherited from struct `Struct`

==(other) : Bool ==, hash(hasher) hash, inspect(io : IO) : Nil inspect, pretty_print(pp) : Nil pretty_print, to_s(io : IO) : Nil to_s

### Instance methods inherited from struct `Value`

==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, __crystal_pseudo_! : Bool __crystal_pseudo_!, __crystal_pseudo_as(type : Class) __crystal_pseudo_as, __crystal_pseudo_as?(type : Class) __crystal_pseudo_as?, __crystal_pseudo_is_a?(type : Class) : Bool __crystal_pseudo_is_a?, __crystal_pseudo_nil? : Bool __crystal_pseudo_nil?, __crystal_pseudo_responds_to?(name : Symbol) : Bool __crystal_pseudo_responds_to?, class class, dup dup, hash(hasher)
hash hash, inspect : String
inspect(io : IO) : Nil inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Constructor Detail

def self.new(identifiers : Array(String | Int32) = [] of String | Int32) #

Creates a new `Prerelease` instance with supplied array of identifiers

def self.parse(str : String) : self #

Parses a `Prerelease` from the given pre-release version string

    require "semantic_version"

    prerelease = SemanticVersion::Prerelease.parse("rc.1.3")
    prerelease # => SemanticVersion::Prerelease(@identifiers=["rc", 1, 3])

##
Instance Method Detail

def <=>(other : self) : Int32 #

The comparison operator.

Returns `-1`, `0` or `1` depending on whether `self`'s pre-release is lower than other's, equal to other's pre-release or greater than other's pre-release.

    require "semantic_version"

    prerelease1 = SemanticVersion::Prerelease.new(["rc", 1])
    prerelease2 = SemanticVersion::Prerelease.new(["rc", 1, 2])

    prerelease1 <=> prerelease2 # => -1
    prerelease1 <=> prerelease1 # => 0
    prerelease2 <=> prerelease1 # => 1

def identifiers : Array(String | Int32) #

Array of identifiers that make up the pre-release metadata

def to_s(io : IO) : Nil #

Returns the string representation of this semantic version's pre-release metadata

    require "semantic_version"

    semver = SemanticVersion.parse("0.27.1-rc.1")
    semver.prerelease.to_s # => "rc.1"